from tkinter import ttk
from tkinter import *
from tkinter.ttk import *
from tkinter import messagebox

class Application(Frame):
  def __init__(self, master = None):
    super().__init__(master)
    self.master = master
    self.pack()
    self.create_widgets()

  def create_widgets(self):
    self.title = '数式電卓CalcGui01'
    self.master.title(self.title)
    self.master.resizable(width = False, height = False)
    self.master.bind('<Key-Return>', self.returnKeyPressed)
    self.master.bind('<Key-Escape>', self.escapeKeyPressed)
    self['padding'] = (6, 6)

    self.labelInput = Label(self)
    self.labelInput['text'] = "式を入力"
    self.labelInput.grid(column = 0, row = 0)
    self.labelOutput = Label(self)
    self.labelOutput['text'] = "計算結果"
    self.labelOutput.grid(column = 0, row = 1)

    self.entryInput = Entry(self)
    self.entryInput.insert(0, '1+2+3')
    self.entryInput.grid(column = 1, row = 0, padx = 4, pady = 4,
      columnspan = 3, sticky = (E, W))
    self.entryOutput = Entry(self)
    self.entryOutput.grid(column = 1, row = 1, padx = 4, pady = 4,
      columnspan = 3, sticky = (E, W))
    self.buttonExit = Button(self)
    self.buttonExit['text'] = '終了'
    self.buttonExit['command'] = self.buttonExitClicked
    self.buttonExit.grid(column = 0, row = 2, padx = 4, pady = 4)
    self.buttonCopy = Button(self)
    self.buttonCopy['text'] = '結果を式へ'
    self.buttonCopy['command'] = self.buttonCopyClicked
    self.buttonCopy.grid(column = 1, row = 2, padx = 4, pady = 4)
    self.buttonClear = Button(self)
    self.buttonClear['text'] = '式を消去'
    self.buttonClear['command'] = self.buttonClearClicked
    self.buttonClear.grid(column = 2, row = 2, padx = 4, pady = 4)
    self.buttonExecute = Button(self)
    self.buttonExecute['text'] = '計算'
    self.buttonExecute['command'] = self.buttonExecuteClicked
    self.buttonExecute['default'] = ACTIVE
    self.buttonExecute.grid(column = 3, row = 2, padx = 4, pady = 4)

  def buttonExitClicked(self):
    app.quit()

  def buttonCopyClicked(self):
    self.entryInput.delete(0, END)
    self.entryInput.insert(0, self.entryOutput.get())
  def buttonClearClicked(self):
    self.entryInput.delete(0, END)
  def buttonExecuteClicked(self):
    try:
      result = eval(self.entryInput.get())
    except:
      messagebox.showerror(self.title, '入力が不適切です')
    else:
      self.entryOutput.delete(0, END)
      self.entryOutput.insert(0, result)

  def returnKeyPressed(self, event):
    self.buttonExecuteClicked()

  def escapeKeyPressed(self, event):
    self.buttonClearClicked()

root = Tk()
app = Application(master = root)
app.mainloop()
